unit MastappTableFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DemoFrm, MastappFrm, OleanderWord8, OleanderAuto, OleanderPrinter,
  OleanderWord7, OleanderController, StdCtrls, Grids, DBGrids, DBCtrls,
  ExtCtrls, Buttons, ComCtrls, DBTables, DB;

type
  TfrmMastappTable = class(TfrmMastapp)
    dscClCustomer: TDataSource;
    tblClCustomer: TTable;
    dscOhOrders: TDataSource;
    tblOhOrders: TTable;
    tblOhOrdersOrderNo: TFloatField;
    tblOhOrdersCustNo: TFloatField;
    tblOhOrdersSaleDate: TDateTimeField;
    tblOhOrdersShipDate: TDateTimeField;
    tblOhOrdersEmpNo: TIntegerField;
    tblOhOrdersShipToContact: TStringField;
    tblOhOrdersShipToAddr1: TStringField;
    tblOhOrdersShipToAddr2: TStringField;
    tblOhOrdersShipToCity: TStringField;
    tblOhOrdersShipToState: TStringField;
    tblOhOrdersShipToZip: TStringField;
    tblOhOrdersShipToCountry: TStringField;
    tblOhOrdersShipToPhone: TStringField;
    tblOhOrdersShipVIA: TStringField;
    tblOhOrdersPO: TStringField;
    tblOhOrdersTerms: TStringField;
    tblOhOrdersPaymentMethod: TStringField;
    tblOhOrdersItemsTotal: TCurrencyField;
    tblOhOrdersTaxRate: TFloatField;
    tblOhOrdersFreight: TCurrencyField;
    tblOhOrdersAmountPaid: TCurrencyField;
    tblOhOrderslufCustomerCompany: TStringField;
    tblOhCustomer: TTable;
    dscIvOrders: TDataSource;
    tblIvOrders: TTable;
    tblIvOrdersOrderNo: TFloatField;
    tblIvOrdersCustNo: TFloatField;
    tblIvOrdersSaleDate: TDateTimeField;
    tblIvOrdersShipDate: TDateTimeField;
    tblIvOrdersEmpNo: TIntegerField;
    tblIvOrdersShipToContact: TStringField;
    tblIvOrdersShipToAddr1: TStringField;
    tblIvOrdersShipToAddr2: TStringField;
    tblIvOrdersShipToCity: TStringField;
    tblIvOrdersShipToState: TStringField;
    tblIvOrdersShipToZip: TStringField;
    tblIvOrdersShipToCountry: TStringField;
    tblIvOrdersShipToPhone: TStringField;
    tblIvOrdersShipVIA: TStringField;
    tblIvOrdersPO: TStringField;
    tblIvOrdersTerms: TStringField;
    tblIvOrdersPaymentMethod: TStringField;
    tblIvOrdersItemsTotal: TCurrencyField;
    tblIvOrdersTaxRate: TFloatField;
    tblIvOrdersFreight: TCurrencyField;
    tblIvOrdersAmountPaid: TCurrencyField;
    tblIvOrderscalTotal: TCurrencyField;
    tblIvOrderslupEmployeeFirstname: TStringField;
    tblIvOrderslupEmployeeLastname: TStringField;
    dscIvItems: TDataSource;
    dscIvCustomer: TDataSource;
    tblIvItems: TTable;
    tblIvItemsOrderNo: TFloatField;
    tblIvItemsItemNo: TFloatField;
    tblIvItemsPartNo: TFloatField;
    tblIvItemsQty: TIntegerField;
    tblIvItemsDiscount: TFloatField;
    tblIvItemslupListPrice: TCurrencyField;
    tblIvItemslupPartdescription: TStringField;
    tblIvItemscalExtendedPrice: TCurrencyField;
    tblIvCustomer: TTable;
    tblIvEmployee: TTable;
    tblIvParts: TTable;
    procedure tblIvOrdersCalcFields(DataSet: TDataSet);
    procedure tblIvItemsCalcFields(DataSet: TDataSet);
    procedure cbxDocumentChange(Sender: TObject);
  private
  public
  end;

implementation

{$R *.DFM}

procedure TfrmMastappTable.tblIvOrdersCalcFields(DataSet: TDataSet);
begin
  inherited;
  tblIvOrderscalTotal.AsFloat := tblIvOrdersItemsTotal.AsFloat + tblIvOrdersFreight.AsFloat;
end;

procedure TfrmMastappTable.tblIvItemsCalcFields(DataSet: TDataSet);
begin
  inherited;
  tblIvItemscalExtendedPrice.AsFloat := tblIvItemsQty.AsInteger * tblIvItemslupListPrice.AsFloat;
end;

procedure TfrmMastappTable.cbxDocumentChange(Sender: TObject);
begin
  olcController.Close;
  tblClCustomer.Close;
  tblOhOrders.Close;
  tblOhCustomer.Close;
  tblIvOrders.Close;
  tblIvItems.Close;
  tblIvCustomer.Close;
  tblIvParts.Close;
  tblIvEmployee.Close;
  case cbxDocument.ItemIndex of
    repCustomerList : begin
                        tblClCustomer.Open;
                        olcController.Datasource := dscClCustomer;
                        olcController.DatasourceMap.Clear;
                        olcController.DatasourceMap.Add('Customer=dscClCustomer');
                      end;
    repOrderHistory : begin
                        tblOhCustomer.Open;
                        tblOhOrders.Open;
                        olcController.Datasource := dscOhOrders;
                        olcController.DatasourceMap.Clear;
                        olcController.DatasourceMap.Add('Orders=dscOhOrders');
                      end;
    repInvoice      : begin
                        tblIvOrders.Open;
                        tblIvItems.Open;
                        tblIvCustomer.Open;
                        tblIvEmployee.Open;
                        tblIvParts.Open;
                        olcController.Datasource := dscIvOrders;
                        olcController.DatasourceMap.Clear;
                        olcController.DatasourceMap.Add('Orders=dscIvOrders');
                        olcController.DatasourceMap.Add('Item=dscIvItems');
                        olcController.DatasourceMap.Add('Customer=dscIvCustomer');
                      end;
  end;
  oleserver.DocName := 'Mastapp ' + cbxDocument.Items[cbxDocument.itemindex] + ' (TTABLE).doc';
  dbgDemo.Datasource := olcController.Datasource;
  dbnDemo.Datasource := olcController.Datasource;
  inherited;
end;

end.
